/*
	camerge.c
	
	2000-04-17	쐬iĂƁ[j
	
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define COPY_BUFFER		4096

typedef unsigned char	uchar, byte;
typedef unsigned long	ulong;


long
getNextOffset(FILE *fi)
{
	uchar	c[4];
	
	if (fread(c, 1, 4, fi) < 4) return -1L;
	
	return (ulong)(c[1]) | ((ulong)(c[2]) << 8) | ((ulong)(c[3]) << 16);
}


long
copyFile(FILE *fo, FILE *fi)
{
	long	cnt;
	int		nr, nw;
	char	*b;
	
	b = malloc(COPY_BUFFER);
	if (!b) return -1L;
	cnt = 0;
	
	while(1) {
		nr = fread(b, 1, COPY_BUFFER, fi);
		if (nr == 0) break;
		nw = fwrite(b, 1, nr, fo);
		if (nw != nr) break;
		cnt += (long)nw;
	}
	
	if (b) free(b);
	return cnt;
}

void
usage()
{
	const char	msg[] = 
		"camerge basename dest.ext\n"
		;
	
	printf("%s", msg);
}

int
main(int argc, char **argv)
{
	char	s[256];
	char	*srcbase, *dst;
	FILE	*fi, *fo;
	int		i;
	int		result;
	long	cnt, ofs, cpyd;
	
	if (argc <=2) {
		usage();
		return 1;
	}
	
	srcbase = argv[1];
	dst = argv[2];
	
	result = 0;
	
	fo = fopen(dst, "wb");
	if (!fo) {
		fprintf(stderr, "%s can't create.\n", dst);
		return 1;
	}
	
	cnt = 0L;
	for(i = 1; i < 10; i++) {
		sprintf(s, "%s.CA%1d", srcbase, i);
		printf("file %s...", s);
		fi = fopen(s, "rb");
		if (!fi) { printf("not found\n"); break; }
		ofs = getNextOffset(fi);
		if (ofs < 0 || cnt != ofs) {
			printf("incorrect offset.\n");
			fclose(fi);
			result = 1;
			break;
		}
		cpyd = copyFile(fo, fi);
		fclose(fi);
		if (cpyd < 0) {
			printf("stream error.\n");
			result = 1;
			break;
		}
		printf("ok\n");
		cnt += cpyd;
	}
	
	fclose(fo);
	return result;
}
